// LICENSE : MIT
"use strict";

var _parser = require("./parser");

var _aceCheck = require("./ace-check");

var path = require("path");


(0, _aceCheck.aceCheck)();

module.exports = {
    hooks: {
        "page:before": function pageBefore(page) {
            var options = this.options.pluginsConfig["include-codeblock"];
            var pageDir = path.dirname(page.rawPath);
            var results = (0, _parser.parse)(page.content, pageDir, options);
            results.forEach(function (result) {
                var target = result.target,
                    replaced = result.replaced;

                page.content = page.content.replace(target, replaced);
            });
            return page;
        }
    }
};
//# sourceMappingURL=include-codeblock.js.map